import numcmc
import tabledef

rowindeces=tabledef.indexA
colindeces=rowindeces

xo={}
for i in rowindeces:
    for j in colindeces:
        xo[i,j]=tabledef.ctable[1][1][i][j]

index=[(i,j) for i in rowindeces for j in colindeces]
subtablesofrow=[[p for p in index if p[0]==k]  for k in rowindeces]
subtablesofcol=[[p for p in index if p[1]==k]  for k in colindeces]

subtableforH0=subtablesofrow+subtablesofcol

markovbasis=numcmc.BasicMoves(rowindeces,colindeces)

bumpu=numcmc.TakoBumpu()

mcmcsampler=numcmc.MCMCSamplerWithMarkovBasis(xo,markovbasis,bumpu)
#mcmcsampler.burnin(600000)

teststatistics=numcmc.ChisqTestStatistics(xo,subtableforH0,eps=0.000001)

tester=numcmc.SimpleMCMCSimulator(teststatistics,mcmcsampler)

#tester.runSimulation(1000000,burnin=1000000,printflag=True,printinterval=1000)
tester.runSimulation(1000000,burnin=1000000,printflag=True,printinterval=1000)

p=tester.getSimulatedPValue()
print "#P=",p
print "#(reject,reject,st,moved)=",mcmcsampler.getRejectionData()
