import numcmc
import tabledef

rowindeces=tabledef.indexA
colindeces=rowindeces

xo={}
for i in rowindeces:
    for j in colindeces:
        xo[i,j]=tabledef.table[1][1][i][j]

index=[(i,j) for i in rowindeces for j in colindeces]
subtablesofrow=[[p for p in index if p[0]==k]  for k in rowindeces]
subtablesofcol=[[p for p in index if p[1]==k]  for k in colindeces]

categories=[[-1],[1],[3],[4,8,9],[6],[2],[5,7]]

diagonalblocks=[[(i,j) for i in c for j in c] for c in categories]
diagonalsubtable=[p for p in diagonalblocks]

subtableforH0=subtablesofrow+subtablesofcol+diagonalsubtable

markovbasis=numcmc.OgawaMarkovBasisForBlockDiagnal(rowindeces,colindeces,diagonalblocks)
bumpu=numcmc.TakoBumpu()

mcmcsampler=numcmc.MCMCSamplerWithMarkovBasis(xo,markovbasis,bumpu)

#mcmcsampler.burnin(600000)

teststatistics=numcmc.ChisqTestStatistics(xo,subtableforH0,eps=0.000001)

tester=numcmc.SimpleMCMCSimulator(teststatistics,mcmcsampler)
tester.runSimulation(1000000,burnin=1000000,printflag=True,printinterval=1000)
p=tester.getSimulatedPValue()
print "#P=",p
print "#(reject,reject,st,moved)=",mcmcsampler.getRejectionData()
