import numcmc
import tabledef

rowindeces=tabledef.indexA
colindeces=rowindeces

xo={}
for i in rowindeces:
    for j in colindeces:
        xo[i,j]=tabledef.table[1][1][i][j]

index=[(i,j) for i in rowindeces for j in colindeces]
subtablesofrow=[[p for p in index if p[0]==k]  for k in rowindeces]
subtablesofcol=[[p for p in index if p[1]==k]  for k in colindeces]

#categories=[[i] for i in rowindeces]
#categories=[[-1],[1],[3],[4,8,9],[6],[2],[5,7]]
#categories=[[-1],[1],[2,6],[3,4,8,9],[5,7]]
#categories=[[-1],[1,3,8,9],[2,4,5,6,7]]
#categories=[[-1],[1,3,9],[2,4,5,6,7,8]]
categories=[[-1],[1],[2,3,4,5,6,7,8,9]]

blocks=[[(i,j) for i in ci for j in cj] for ci in categories for cj in categories]

subtableforH0=subtablesofrow+subtablesofcol
subtableforH1=subtablesofrow+subtablesofcol+blocks

markovbasis=numcmc.BasicMovesFixingSubtables(rowindeces,colindeces,blocks)
bumpu=numcmc.TakoBumpu()

mcmcsampler=numcmc.MCMCSamplerWithMarkovBasis(xo,markovbasis,bumpu)

#condition=numcmc.ConditionForSubtableModel(subtablesofrow)
#mcmcsampler=numcmc.MCMCSamplerWithMarkovBasis(xo,markovbasis,kimubumpu,condition)

#mcmcsampler.burnin(600000)



#teststatistics=numcmc.GTestStatistics(xo,subtableforH0,subtableforH1,eps=0.000001)
teststatistics=numcmc.ChisqTestStatistics(xo,subtableforH0,eps=0.000001)

#condition=numcmc.ConditionForSubtableModel(subtablesofrow)
#mcmcsampler=numcmc.MCMCSamplerWithMarkovBasis(xo,markovbasis,kimubumpu,condition)

#mcmcsampler.burnin(10000)

tester=numcmc.SimpleMCMCSimulator(teststatistics,mcmcsampler)
tester.runSimulation(1000000,burnin=1000000,printflag=True,printinterval=1000)
p=tester.getSimulatedPValue()
print "#P=",p
print "#(reject,reject,st,moved)=",mcmcsampler.getRejectionData()

